from jnpr.junos import Device
from jnpr.junos.utils.config import Config
from jnpr.junos.exception import *
import mysql.connector
import sys
import argparse
import time
parser = argparse.ArgumentParser(description='Add a vlan to all bakchauls on the network.')
parser.add_argument('-d','--device', help='Host IP', required=False)
parser.add_argument('-a','--area', help='Area number', required=False)
parser.add_argument('-c','--includecore', help='Include core switches in results', action="store_true", required=False)
parser.add_argument('-v','--vlanid', help='VLAN ID to add', required=True)
parser.add_argument('-n','--vlanname', help='Name of VLAN to add', required=True)
args = parser.parse_args()


##This code querys the powercheck db for basestation ips to use in the add_vlan
db_connection = mysql.connector.connect(user='root', password='bgt567UJM',host='hidb.clhdx2lki42e.eu-west-1.rds.amazonaws.com',database='CWA',buffered=True)
#db_connection = mysql.connector.connect(user='powercheck', password='buyg867tgf94rn',host='hicritical-cluster.cluster-clhdx2lki42e.eu-west-1.rds.amazonaws.com',database='powercheck',buffered=True)
power_db = db_connection.cursor()
#power_db = db_connection.cursor(dictionary=True) adds all querys for dictionary

queryospf = "SELECT distinct ospf_area  FROM CWA.BaseStations ORDER BY ospf_area;"
power_db.execute(queryospf)
ospf_output = power_db.fetchall()

datetime = time.strftime("%Y-%m-%d %H:%m")
print(datetime)
ospf_area = []
ospf = []
everyospf = []
devlist = {}

#query for all devlist
ospfall = "SELECT switch_ip FROM CWA.BaseStations"
power_db.execute(ospfall)
all_ospf = power_db.fetchall()

for every in all_ospf:
    everyospf.append(str(every[0]))

devlist['all'] = everyospf

for ospf in ospf_output:
#query the db again with %x and add to devlist
    ospf_area.append(str(ospf[0]))  #full ospf area code

for y in ospf_area:

    #last character in ospf sql field
    ospf_id = y.replace('0.0.0.','')
    switches = []

#query for each ospf area
    queryall = "SELECT switch_ip FROM CWA.BaseStations WHERE ospf_area = %s"
    power_db.execute(queryall, (y,))
    all_output = power_db.fetchall()

    #assign each switch to ospf are in devlist
    for swit in all_output:

        switches.append(str(swit[0]))

    devlist[ospf_id] = switches
    #print (switches)

#print "count", len(devlist), "I made this one!",(devlist)

def add_vlan(device):

    user = 'netbot'
    passwd = 'fd38*M0i'
    sys.stdout.write('connecting to %s ...' % device)
    sys.stdout.flush()
    els = False
    dev = Device(device,user=user,password=passwd)
    dev.auto_probe = 5
    try:
        dev.open()
        print('ok')
        switchinfo = dev.rpc.get_software_information()
        try:
            hostname =  switchinfo.getchildren()[0].getchildren()[1]
            print(hostname.findtext('host-name'))
            version = switchinfo.getchildren()[0].getchildren()[1]
            if version.findtext('junos-version'):
                if version.findtext('junos-version')[0:0+2] == "14":
                    print('Using ELS formats...')
                    els = True
        except Exception as err:
            try:
                print(switchinfo.findtext('host-name'))
            except Exception as err:
                print('Couldn\'t find host name...')

        swint = dev.rpc.get_interface_information()
        cu = Config(dev)
        if cu.diff():
            print_cmds_only = True
            print('Can\'t add VLAN to ' + device + ' as there is a config pending, run the following commands manually :')
        else:
            print_cmds_only = False

        commit_comment = 'Added VLAN ' + args.vlanname + ' - ID ' + args.vlanid

        for interface in swint.getiterator('physical-interface'):
            if els:
                if interface.findtext('description'):
                    desc = interface.findtext('description').strip()
                    if desc.find('***backhaul***') > -1:
                        set_cmd = 'set interfaces ' + interface.findtext('name').strip() + ' unit ' + args.vlanid + ' vlan-id ' + args.vlanid
                        if print_cmds_only:
                            print(set_cmd)
                        else:
                            try:
                                cu.load(set_cmd, format='set')
                            except Exception as err:
                                print('Couldn\'t load set command:')
                                print(set_cmd)
                            if interface.findtext('description'):
                                display_desc = interface.findtext('description').strip()
                            else:
                                display_desc = '<NO DESCRIPTION>'
                            print('Added VLAN to ' + interface.findtext('name').strip() + ' - ' + display_desc)
                        set_cmd = 'set vlans ' + args.vlanname + ' interface ' + interface.findtext('name').strip()+ '.' + args.vlanid
                        if print_cmds_only:
                            print(set_cmd)
                        else:
                            cu.load(set_cmd, format='set')
                            print('Added interface ' + interface.findtext('name').strip() + ' to VLAN')
            else:
                if interface.findtext('logical-interface/description'):
                    if interface.findtext('logical-interface/description').strip() == '***backhaul***':
                        set_cmd = 'set vlans ' + args.vlanname + ' vlan-id ' + args.vlanid
                        if print_cmds_only:
                            print(set_cmd)
                        else:
                            cu.load(set_cmd, format='set')
                            print(commit_comment)

                        set_cmd = 'set interfaces ' + interface.findtext('name').strip() + ' unit 0 family ethernet-switching vlan members ' + args.vlanname
                        if print_cmds_only:
                            print(set_cmd)
                        else:
                            try:
                                cu.load(set_cmd, format='set')
                            except Exception as err:
                                print('Couldn\'t load set command:')
                                print(set_cmd)
                            if interface.findtext('description'):
                                display_desc = interface.findtext('description').strip()
                            else:
                                display_desc = '<NO DESCRIPTION>'
                            print('Added VLAN to ' + interface.findtext('name').strip() + ' - ' + display_desc)
        if cu.diff() and not print_cmds_only:
            try:
                cu.commit(comment=commit_comment + ' via python')
                print('Done on ' + device + ' ...')
            except Exception as err:
                print('Couldn\'t commit on ' + device + ', the config should be there though, try to commit manually.')
        else:
            if not print_cmds_only:
                print('VLAN already on all backhauls on this device')
        dev.close()
    except Exception as err:
            print('Couldn\'t connect to ' + device + '...')
            print(err)

done_CORE = False

if not args.device:
    if not args.area:
        if args.includecore:
            print('CORE:')
            done_CORE = True
            for device in devlist['0']:
                add_vlan(device)
        else:
            for device in devlist['all']:
                add_vlan(device)
    else:
        cnx = mysql.connector.connect(user='root', password='bgt567UJM',host='hidb.clhdx2lki42e.eu-west-1.rds.amazonaws.com',database='CWA',buffered=True)
        #cnx = mysql.connector.connect(user='powercheck', password='buyg867tgf94rn',host='hicritical-cluster.cluster-clhdx2lki42e.eu-west-1.rds.amazonaws.com',database='powercheck',buffered=True)
        devices = cnx.cursor()
        query = "SELECT switch_ip FROM CWA.BaseStations WHERE ospf_area = '0.0.0.%s'" % (args.area)
        devices.execute(query)
        for device in devices:
            add_vlan(device[0])
else:
    add_vlan(args.device)

if args.includecore and not done_CORE:
    print('CORE:')
    for device in devlist['0']:
        add_vlan(device)

print('All done!')
